/** \file Render.h
<h2> Main rendering and initalisation module </h2> <br>
Copyright (C) 2011 Xi Chen <br>

-------------------------------------------------------------------------<br>
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version. <br>

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. <br>

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. <br>
-------------------------------------------------------------------------<br>

\brief Main rendering and initalisation module
\author Xi Chen hypernewbie@gmail.com
\date 15/11/2011

*/

#ifndef __RENDER_H__
#define __RENDER_H__

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <windows.h>
#include <windowsx.h>
#include <d3d9.h>
#include <d3dx9.h>
#include "../EngineHeader/DXInterface.h"
#include "../EngineHeader/DXIntegrate.h"
#include "../EngineHeader/DXRenderPass.h"
#include "../EngineHeader/DXPrimitives.h"
#include "../EngineHeader/DXTexture.h"
#include "../EngineHeader/DXMatrix.h"
#include "../EngineHeader/DXModel.h"
#include "../EngineHeader/DXText.h"
#include "../EngineHeader/DXShader.h"
#include "../EngineHeader/DXSound.h"
#include "../EngineHeader/DXCamera.h"
#include "../GameHeader/SceneSpace.h"
#include "../GameHeader/SceneTerrain.h"
#include "../GameHeader/SceneCubeTunnel.h"
#include "../GameHeader/SceneChrono.h"
#include "../GameHeader/SceneAbstract.h"
#include "../GameHeader/SceneAbstract2.h"
#include "../GameHeader/SceneHuman.h"
#include "../GameHeader/SceneCar.h"

#define CAMERACONTROL_FREELOOK 0
#define CAMERACONTROL_FREEORBIT 1
#define CAMERACONTROL_PATH 2
#define CAMERACONTROL_DEMO 3

#define MUSIC_FILE "Common/Camelopardalis.mp3"
#define MUSIC_FILE2 "Common/edgen_lost.mp3"
#define CONFIG_FILE "config.ini"
#define CONFIG_BUFFER_SIZE 512

//! Desired screen width setting, loaded from file
extern int desiredScreenWidth;
//! Desired screen height setting, loaded from file
extern int desiredScreenHeight;


//! Load settings from file
void loadSettings();

//! Initialize DirectX, demo data and load contents
void initialize();

//! Renders a frame to screen
void renderFrame();

#endif