/** \file SceneCar.h
<h2> Car Scene </h2> <br>
Copyright (C) 2011 Xi Chen <br>

-------------------------------------------------------------------------<br>
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version. <br>

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. <br>

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. <br>
-------------------------------------------------------------------------<br>

\brief Car Scene
\author Xi Chen hypernewbie@gmail.com
\date 15/11/2011

*/

#ifndef __SCENE_CAR_H__
#define __SCENE_CAR_H__

#include "Scene.h"
#include "../EngineHeader/DXTerrain.h"

class SceneCar : public Scene {
    // --> Car scene
    TextureArray carTextures;
    Model carModel;
    Shader carShader;
    LPDIRECT3DCUBETEXTURE9 carCubeMap;
    LPDIRECT3DCUBETEXTURE9 carIrrMap;
    dxPrimitivesObj *carSkyDome;
public:
    void load();
    void render(ShaderGlobalSemantics &shaderSem, D3DXMATRIX &matView, D3DXMATRIX &matProjection);
    void update( D3DXMATRIX &matView, ShaderGlobalSemantics *shaderSem );
    void release();
};


#endif
