/** \file Main.cpp
<h2> Main Entry Module </h2> <br>
Copyright (C) 2011 Xi Chen <br>

-------------------------------------------------------------------------<br>
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version. <br>

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. <br>

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. <br>
-------------------------------------------------------------------------<br>

\brief Main entry module
\author Xi Chen hypernewbie@gmail.com
\date 15/11/2011

*/

#ifndef _RELEASE_
    #define D3D_DEBUG_INFO
#endif

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <windows.h>
#include <windowsx.h>
#include <d3d9.h>
#include <d3dx9.h>
#include "EngineHeader/DXInterface.h"
#include "EngineHeader/DXTexture.h"
#include "GameHeader/Render.h"


//! Handles engine frames
void engineFrame( void (*renderFunction)() = &renderFrame ) {
    MSG windowMessage;
    // Process Messages
    while( PeekMessage(&windowMessage, NULL, 0, 0, PM_REMOVE) ) {
        TranslateMessage(&windowMessage);
        DispatchMessage(&windowMessage);
    }
    if(windowMessage.message == WM_QUIT) exitEngine = true;
    // Update framerate
    wTickTime();
    // Render
    renderFunction();
    dxSwapBuffers();
}

//! Entry function
int main( int argc, char **argv, char **envp ) {
    // ---> Set up and initialise
    loadSettings();
    wCreateWindow(desiredScreenWidth, desiredScreenHeight, NULL);
    dxInitialise( hWnd );
    initialize();
    wInitTimer();
    // --> Main engine loop
    while( !exitEngine ) {
        engineFrame();
    }
    dxPrimitiveRelease();
    dxRelease();
    return EXIT_SUCCESS;
}